import getpass
import os
import pwd

# wifi文件路径 list wifi files
def wifiPath(lpath, lfilelist):
    if os.path.exists(lpath) == False:
        print('network path is not exsit for'+lpath)
        return []
    list = os.listdir(lpath)
    for f in list:
        file = os.path.join(lpath, f)
        if is_chinese(file):
            continue
        if os.path.isdir(file):        
            wifiPath(file, lfilelist)
        else:
            lfilelist.append(file)
    return lfilelist
 
#检查整个字符串是否包含中文
def is_chinese(string):
    for ch in string:
        if u'\u4e00' <= ch <= u'\u9fff':
            return True

    return False


# 获取无线网卡设备名称
def getWifiDeviceName():
    wifiInterfaceName = ''
    re = os.popen('iwconfig ')
    deviceInterfaceStr = re.read()
    deviceInterfaceArr = deviceInterfaceStr.splitlines();
    for line in deviceInterfaceArr:
        strs = line.split(' ')
        temp = strs[0]
        if temp.startswith('wl'):
            wifiInterfaceName = temp.strip()
    return wifiInterfaceName


def getOsInfo():
    output = os.popen('cat /etc/os-release ')
    item_str = output.read()
    items = {}
    for line in item_str.splitlines():
        strs = line.split('=')
        if len(strs)<2:
            continue
        item_key = strs[0]
        item_val = strs[1]
        items[item_key]=item_val
        # items.append({'key':item_key,'val':item_val})
    return items

def getOsCodeName():
    osInfo = getOsInfo()
    if osInfo.get('VERSION_CODENAME'):
        return osInfo.get('VERSION_CODENAME')
    if osInfo.get('CODENAME'):
        return osInfo.get('CODENAME')
    
    return 'tiger'

def get_current_desktop_user():

    current_desktop_username = ''
    current_desktop_uid = 1000

    output = os.popen("  who | grep ':0' | awk -F ' '  '{print $1}'  ")
    current_desktop_username = output.read().strip()
    if current_desktop_username != '':
        current_desktop_uid = pwd.getpwnam(current_desktop_username).pw_uid

    return current_desktop_username,current_desktop_uid