  #! /usr/bin/python
# -*- coding: utf-8 -*-
import code
import re
import sys
from threading import Timer
import datetime
import time
import os
import threading
import json
import logging 
import configparser
import nfsutil
sys.path.append('/opt/nfs-cloud-sync/dist-packages')
sys.path.append('/home/send2ocean/nfsProjects/nfs-cloud-sync-client/dist-packages')
import websocket 
# from gsettingConfig_g007 import background_config,theme_config,screensaver_config,front_configs,mouse_config,taskbar_config,power_config
# from gsettingConfig_tiger import background_config,theme_config,front_configs,mouse_config,taskbar_config,power_config

Log_Format_All = "%(levelname)s %(asctime)s %(thread)s %(process)s %(funcName)s %(lineno)d- %(message)s"
Log_Format = "%(levelname)s %(asctime)s %(thread)s %(funcName)s %(lineno)d- %(message)s"
logging.basicConfig(
    filename="/opt/nfs-cloud-sync/sync_task/nfs-cloud-sync-client-timer.log",
    filemode= 'w',
    format= Log_Format_All,
    level= logging.DEBUG
)

logger = logging.getLogger()



# 云账户本地配置文件夹
configDir = os.path.expanduser('~')+"/.caccount/config"
#wifi配置文件目录1qaz1qaz

networkDir ='/etc/NetworkManager/system-connections'
# 服务地址
host = 'wss://cloudaccount.os.nfschina.com/caccount-api/v1/ws?token='
ws = websocket.WebSocket()
sys_codename = 'tiger'
sys_codename = nfsutil.getOsCodeName()
# 根据不同系统 加载不同配置
if sys_codename == 'tiger':
    from gsettingConfig_tiger  import background_config,theme_config,screensaver_config,front_configs,mouse_config,taskbar_config,power_config
else:
    from gsettingConfig_g007 import background_config,theme_config,screensaver_config,front_configs,mouse_config,taskbar_config,power_config

# 线程组
threads = {}
websockets = {}
userlist = []
userSwitchConfig={}
# 配置字典
configDict = {}
# 任务间隔 秒
timer_interval = 60
 
# read ini file config
try:
    iniPath=os.path.join('/opt/nfs-cloud-sync/conf','cloud.ini')
    inicf = configparser.ConfigParser()
    inicf.read(iniPath)
    refresh_intevel = inicf.get('serverConfig','refresh_intevel')
    server_address = inicf.get('serverConfig','server_address')
except Exception:
    logger.debug('get ini file error')
else:
    logger.debug('get ini file ok')
    timer_interval = int(refresh_intevel)
    host = 'wss://'+server_address+'/v1/ws?token='
#                       #######################dev used begin################################ 
# server_address = "40.40.10.60:8080"
# host = 'ws://'+server_address+'/v1/ws?token='
########################dev used end#################################
# 配置开关
issyn = 0
is_desktop = 0
is_font = 0
is_mouse = 0
is_power = 0
is_screen = 0
is_taskbar = 0
is_theme = 0
is_network = 0

class Ws(object):
    def __init__(self,username):
        self.ws = None
        self.username = username
    # websocket 主要逻辑入口
    def websocket_logic(self):
        
        global host
        global sys_codename
        global websockets
        sys_codename = nfsutil.getOsCodeName()
        token = getUserToken(self.username)
        if len(token)>0:
            logger.debug(host+token+"&codename="+sys_codename)
            self.ws = websocket.WebSocketApp(host+token+"&codename="+sys_codename,
                                        on_message=self.on_message,
                                        on_error=self.on_error,
                                        on_close=self.on_close,
                                        on_open=self.on_open)
            websockets[self.username] = self.ws
            # 一直运行
            self.ws.run_forever()
            # ws.run_forever(ping_interval=10,ping_payload="ppingggg")
            logger.debug('websocket logic over!!!')

    # 接收到消息
    def on_message(self,ws, message):
        global sys_codename
        logger.debug("### on_message ###")
        logger.debug( message)
        if message == 'pong':
            return
        msg = json.loads(message)
        codename = msg.get('sys_codename')
        logger.debug(codename)
        if codename != sys_codename:
            logger.debug('sys code is diffrent ,return')
            return
        configs = msg.get('config')
        logger.debug(configs)
        if len(configs) == 0:
            # get config from server is null
            uploadConfig(ws,self.username)
        else:
            applyConfig(configs,self.username)

    def on_error(sefl,ws, error):
        logger.debug("### on_error ###")
        logger.debug(error)
        logger.debug(type(error))
        if type(error)==ConnectionResetError or type(error)==websocket._exceptions.WebSocketConnectionClosedException :
            logger.debug("try to reconnect..")
            token = getUserToken1()
            if len(token)>0:
                 pass

    def on_close(sefl,ws):
        logger.debug("### on_close ###")

    def on_open(sefl,ws):
        logger.debug("### on_open ###")

# 从用户文件获取配置开关项 是否同步 ，同步哪些项
def getConfigJson(username):
    configJson = "/home/"+username+"/.caccount/config/config.json"
    if os.path.isfile(configJson):
        configJsonFile = open(configJson, 'r')
        configStr = configJsonFile.read()
        # logger.debug(configStr)
        configJsonFile.close()
        # {"desktop":2,"font":2,"issyn":2,"mouse":2,"network":2,"power":2,"screen":0,"taskbar":2,"theme":2}
        return json.loads(configStr)
    else:
        logger.debug('can not found config file for user: '+username)
        return {"desktop":0,"font":0,"issyn":0,"mouse":0,"network":0,"power":0,"screen":0,"taskbar":0,"theme":0}

    

# 上传配置
def uploadConfig(ws,username):
    global configDict
    global sys_codename
    logger.debug('begin upload config for '+username)
    if not configDict.get(username):
        logger.debug('global config is none,bengin get local config..')
        tmpConfig = getLocalConfig(username)
        tmpConfig['time'] = time.time()
        configDict[username] = tmpConfig
    res={}
    res['sys_codename'] = sys_codename
    res['config'] = configDict[username] 
    msg = json.dumps(res)

    try:
        ws.send( msg)
        logger.debug(' config have upload to server for '+username)
    except websocket._exceptions.WebSocketConnectionClosedException:
        logger.debug('send msg error')
    logger.debug('end upload config  for '+username)

# 从配置文件 刷新开关项
def refreshSwitchItem(username):
    global userSwitchConfig
    config = getConfigJson(username)
    
    userSwitchConfig[username] = config
    # issyn = config['issyn']
    # is_desktop = config['desktop']
    # is_font = config['font']
    # is_mouse = config['mouse']
    # is_power = config['power']
    # is_screen = config['screen']
    # is_taskbar = config['taskbar']
    # is_theme = config['theme']
    # is_network= config['network']


# 获取本地配置 
def getLocalConfig(username):
    logger.debug('bengin getLocalConfig for '+username)
    refreshSwitchItem(username)
    # local configs
    configTmpDict = {}
    global userSwitchConfig
    config =  userSwitchConfig[username] 
    issyn = config['issyn']
    is_desktop = config['desktop']
    is_font = config['font']
    is_mouse = config['mouse']
    is_power = config['power']
    is_screen = config['screen']
    is_taskbar = config['taskbar']
    is_theme = config['theme']
    is_network= config['network']

    if issyn == 0:
        logger.debug('no sysnc config ')
        return {}
    global networkDir
    uid = getUid(username)
    sudocmd = 'sudo -u '+username+' XDG_RUNTIME_DIR=/run/user/'+uid+' DBUS_SESSION_BUS_ADDRESS=unix:path=/run/user/'+uid+'/bus '
    logger.debug(sudocmd)
    global configDict
    global sys_codename
    # network wifi
    if is_network ==2:
        # 如果没有无线网卡 保持服务端配置不变
        wifiDeviceName = nfsutil.getWifiDeviceName()
        if wifiDeviceName:
            tmp_configs = []
            #list wifi files
            lfilelist = nfsutil.wifiPath(networkDir, [])
            for f in lfilelist:
                
                wfConfDict={}
                wificf = configparser.ConfigParser()
                wificf.read(f)
                wfConfDict['connection id'] = wificf.get('connection','id')
                wfConfDict['connection type'] = wificf.get('connection','type')
                # logger.debug(wfConfDict['connection type'] != 'wifi')
                if wfConfDict['connection type'] != 'wifi':
                    logger.debug('not wifi connection...')
                    break  
                logger.debug('get wifi connection info...') 
                wfConfDict['wifi ssid'] = wificf.get('wifi','ssid')
                wfConfDict['wifi-security key-mgmt'] = wificf.get('wifi-security','key-mgmt')
                wfConfDict['wifi-security psk'] = wificf.get('wifi-security','psk')

                tmp_configs.append({"wifiKey":f,"wifiVal":wfConfDict})
            tmp_configs.sort(key=lambda k:k.get("wifiKey"))
            configTmpDict['network'] = tmp_configs
        else:
            configTmpDict['network'] = configDict['network'] 
     
    if is_desktop == 2:
        schema = background_config['schema']
        keys = background_config['keys']
        deskconfigObj={}
        for i in keys:
            ischema = i['s']
            ikeys = i['k']
            desktopConfigs = []
            for key in ikeys:
                res = os.popen(sudocmd+'gsettings get '+ischema+' '+key)
                v = res.read()
                v=v.strip('\n')
                desktopConfigs.append({'k': key, 'v': v})
            deskconfigObj[ischema] = desktopConfigs
        configTmpDict[schema] = deskconfigObj

    if is_font == 2:
        schema = front_configs['schema']
        keys = front_configs['keys']
        configObj={}
        for i in keys:
            ischema = i['s']
            ikeys = i['k']
            configs = []
            for key in ikeys:
                res = os.popen(sudocmd+'gsettings get '+ischema+' '+key)
                v = res.read()
                v=v.strip('\n')
                configs.append({'k': key, 'v': v})
            configObj[ischema] = configs
        configTmpDict[schema] = configObj
 

    if is_theme == 2:
        schema = theme_config['schema']
        keys = theme_config['keys']
        configObj={}
        for i in keys:
            ischema = i['s']
            ikeys = i['k']
            configs = []
            for key in ikeys:
                res = os.popen(sudocmd+'gsettings get '+ischema+' '+key)
                v = res.read()
                v=v.strip('\n')
                configs.append({'k': key, 'v': v})
            configObj[ischema] = configs
        configTmpDict[schema] = configObj
 
    if is_mouse == 2:
         
        schema = mouse_config['schema']
        keys = mouse_config['keys']
        configObj={}
        for i in keys:
            ischema = i['s']
            ikeys = i['k']
            configs = []
            for key in ikeys:
                res = os.popen(sudocmd+'gsettings get '+ischema+' '+key)
                v = res.read()
                v=v.strip('\n')
                configs.append({'k': key, 'v': v})
            configObj[ischema] = configs
        #imwheel 获取鼠标滚轮速度
        # if sys_codename=='4.0-G007':
        #     res = os.popen('cat /home/'+username+'/.imwheelrc')
        #     v = res.read()
        #     configObj['imwheel_config'] = v
        configTmpDict[schema] = configObj

    if is_power == 2:
         
        schema = power_config['schema']
        keys = power_config['keys']
        configObj={}
        for i in keys:
            ischema = i['s']
            ikeys = i['k']
            configs = []
            for key in ikeys:
                res = os.popen(sudocmd+'gsettings get '+ischema+' '+key)
                v = res.read()
                v=v.strip('\n')
                configs.append({'k': key, 'v': v})
            configObj[ischema] = configs
        configTmpDict[schema] = configObj
    
    if os.sysconf_names != '4.0-G007':
        is_screen = 0
     
    if is_screen == 2:
        
        schema = screensaver_config['schema']
        keys = screensaver_config['keys']
        configObj={}
        for i in keys:
            ischema = i['s']
            ikeys = i['k']
            configs = []
            for key in ikeys:
                res = os.popen(sudocmd+'gsettings get '+ischema+' '+key)
                v = res.read()
                v=v.strip('\n')
                configs.append({'k': key, 'v': v})
            configObj[ischema] = configs
        configTmpDict[schema] = configObj

    if is_taskbar == 2:
        schema = taskbar_config['schema']
        keys = taskbar_config['keys']
        configObj={}
        for i in keys:
            ischema = i['s']
            ikeys = i['k']
            configs = []
            for key in ikeys:
                res = os.popen(sudocmd+'gsettings get '+ischema+' '+key)
                v = res.read()
                v=v.strip('\n')
                configs.append({'k': key, 'v': v})
            configObj[ischema] = configs
        configTmpDict[schema] = configObj
    logger.debug('end getLocalConfig')   
    # logger.debug(str(configTmpDict))
    return configTmpDict

# 鼠标滚轮配置
def doChangeImWheel(rc,username):
    imwheelrc = open('/home/'+username+'/.imwheelrc','w')
    imwheelrc.write(str(rc))
    imwheelrc.close()
    # res = os.popen('imwheel -k')
     
# 执行gseting命令
def doChange(server_config,schema,username):
    if schema == 'network':
        doChangeNetwork(server_config,schema)
        return
    uid = getUid(username)
    sudocmd = 'sudo -u '+username+' XDG_RUNTIME_DIR=/run/user/'+uid+' DBUS_SESSION_BUS_ADDRESS=unix:path=/run/user/'+uid+'/bus '
   
    sc = server_config.get(schema)
    if sc :
        pass
    else:
        return
    for ssc in sc:
        if ssc == 'imwheel_config':
            logger.debug(sc[ssc])
            doChangeImWheel(sc[ssc],username)
            continue
        for kv in sc[ssc]:
            k = kv['k']
            v = kv['v']
            if v.startswith('uint32'):
                v = v.replace("uint32 ","")
            
            if k == 'enabled-applets':
                cmd = sudocmd+'gsettings set '+ssc+' '+k+'  "'+v+'"'
            else:
                cmd = sudocmd+'gsettings set '+ssc+' '+k+' '+v
            
            os.popen(cmd)


# 写入网络配置文件
def doChangeNetwork(server_config,schema):
    sc = server_config[schema]
    wifiInterfaceName = nfsutil.getWifiDeviceName()
    if wifiInterfaceName:
        logger.debug("wifi device name is : "+wifiInterfaceName)
    else:
        return
    #list wifi files
    lfilelist = nfsutil.wifiPath(networkDir, [])
    
    for c in sc:
        logger.debug(c['wifiKey'])
        # logger.debug(c['wifiVal'])
        wifiKey = c['wifiKey']
        wifiVal = c['wifiVal']
        if wifiKey in lfilelist :
            logger.debug('in wifi list')
        else:
            logger.debug('not in wifi list ,nmcli add ')
            addcmd = 'nmcli connection add type wifi ifname '+wifiInterfaceName+' con-name '+wifiVal.get('connection id')+' ssid  '+wifiVal['wifi ssid']+'  wifi-sec.key-mgmt '+wifiVal['wifi-security key-mgmt']+' wifi-sec.psk  '+wifiVal['wifi-security psk']
            logger.debug(addcmd)
            res = os.popen(addcmd)
            v = res.read()
            logger.debug(v)
    logger.debug('更新网络配置文件结束')   
     
# 更改本地配置
def applyConfig(message,username):
    global configDict
    logger.debug('apply config to local begin')
     
    server_config = json.loads(message)
    if  configDict.get(username) :
        logger.debug('get configDict for '+username)
        # compare server vs  local
        s_time = server_config['time']
        l_time = configDict[username]['time']
        if s_time < l_time:
            return
    
    configDict[username] = server_config
    refreshSwitchItem(username)
    global userSwitchConfig
    config =  userSwitchConfig[username] 
    issyn = config['issyn']
    is_desktop = config['desktop']
    is_font = config['font']
    is_mouse = config['mouse']
    is_power = config['power']
    is_screen = config['screen']
    is_taskbar = config['taskbar']
    is_theme = config['theme']
    is_network= config['network']
    if issyn == 0:
        return
    if is_network == 2:   
        schema = 'network'
        doChange(server_config,schema,username)

    if is_desktop == 2:   
        schema = background_config['schema']
        doChange(server_config,schema,username)
             
    if is_font == 2:
        schema = front_configs['schema']
        doChange(server_config,schema,username)

    if is_theme == 2:
        schema = theme_config['schema']
        doChange(server_config,schema,username)

    if is_mouse == 2:
        schema = mouse_config['schema']
        doChange(server_config,schema,username)

    if is_power == 2:
        schema = power_config['schema']
        doChange(server_config,schema,username)

    if is_screen == 2:
        schema = screensaver_config['schema']
        doChange(server_config,schema,username)

    if is_taskbar == 2:
        schema = taskbar_config['schema']
        doChange(server_config,schema,username)
    logger.debug('apply config to local end for user '+ username)


# 比较本地配置字典是否有变化
def compareTask(ws,username):

    if getUserToken(username):
        pass
    else:
        logger.debug('no token found,ws closed...')
        ws.close()

    global configDict
    refreshSwitchItem(username)
    global userSwitchConfig
    config =  userSwitchConfig[username] 
    issyn = config['issyn']
    
    if issyn == 0:
        return
    tmpConfig = getLocalConfig(username)
    tmpConfig['time'] = configDict.get(username).get('time')
    if configDict.get(username) == tmpConfig:
        logger.debug('compareTask:config not change')
        try:
            ws.send( 'ping' )
        except websocket._exceptions.WebSocketConnectionClosedException:
            logger.debug('send ping error')
    else:
        logger.debug(tmpConfig )
        logger.debug(configDict.get(username) )
        logger.debug('compareTask:config  changed for '+username)
        tmpConfig['time'] = time.time()
        configDict[username] = tmpConfig
        uploadConfig(ws,username)
        
# get user list
def getUserList():
    output = os.popen('cat /etc/passwd | grep /home')
    users = output.read()
    userlist = []
    for line in users.splitlines():
        strs = line.split(':')
        user = strs[0]
        uid = strs[2]
        userlist.append({'user':user,'uid':uid})
    return userlist
def getUserToken(username):
    global configDir
    configDir = "/home/"+username+"/.caccount/config"
    tokenJson = configDir+"/token.json"
    # logger.debug(tokenJson)
    if os.path.isfile(tokenJson):
        tokenJsonFile = open(tokenJson, 'r')
        token = tokenJsonFile.read()
        tokenJsonFile.close()
        return token
    else:
        logger.debug('can not found token file for user:'+username)
        return ""
def getUserToken1():
    global username
    global uid
    global sudocmd

    userlist = getUserList()
    for userInfo in userlist:
        token = getUserToken(userInfo['user'])
        if len(token)>0:
            username = userInfo['user']
            uid = userInfo['uid']
            sudocmd = 'sudo -u '+username+' XDG_RUNTIME_DIR=/run/user/'+uid+' DBUS_SESSION_BUS_ADDRESS=unix:path=/run/user/'+uid+'/bus '
            return token
    return ''

def getUserToken2():
    global username
    global uid
    global sudocmd
  
    token = getUserToken(username)
    if len(token)>0:
        sudocmd = 'sudo -u '+username+' XDG_RUNTIME_DIR=/run/user/'+uid+' DBUS_SESSION_BUS_ADDRESS=unix:path=/run/user/'+uid+'/bus '
        return token
    return ''

def userThreadExsit(username):
    for t in threads:
        if t.name == username:
            return True
    return False


def getUid(username):
    global userlist
    for user in userlist:
        uname = user['user']
        if uname == username:
            return user['uid']
    return 1000
    
def start(username):
    ws = Ws(username)
    ws.websocket_logic()
# 执行主任务
def mainTask():
    global threads
    global websockets
    global configDict
    global userlist
    
    # username,uid = nfsutil.get_current_desktop_user()
    logger.debug('#########################begin task at TimeNow:%s' % (datetime.datetime.now().strftime('%Y-%m-%d %H:%M:%S')))
    userlist = getUserList()
    logger.debug("threads array len "+ str( len(threads) ))
    for user in userlist:
        username = user['user']
        logger.debug("username "+username)
        if threads.get(username):
            
            t = threads.get(username)
            logger.debug(" t.isAlive() = "+ str(t.is_alive()) )
            if t.is_alive():
                compareTask(websockets[username],username)
            else:
                del threads[username]
        else:
            if getUserToken(username):
                logger.debug(" add thread for  "+ username )
                t = threading.Thread(target=start, args=(username,))
                # t.is_alive()
                threads[username] = t
                t.start()
            else:
                 logger.debug("no login")
    t = Timer(timer_interval, mainTask)
    t.start()
 

if __name__ == "__main__":
    mainTask()

